package api_types

import (
	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/gin_gonic"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/go_swagger"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_types/mojolicious"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/models"
)

func GetApiType(in models.ApiTypeName) (ApiTypeInterface, error) {
	if in == "" {
		return nil, errors.BadRequestf("missing parameter")
	}

	if !in.IsValid() {
		return nil, errors.NotValidf("invalid parameter")
	}

	switch in {
	case models.ApyTypeName_GIN_GONIC:
		return gin_gonic.ApiType{}, nil
	case models.ApyTypeName_GO_SWAGGER:
		return go_swagger.ApiType{}, nil
	case models.ApyTypeName_MOJOLICIOUS:
		return mojolicious.ApiType{}, nil
	}

	return nil, errors.NotFoundf("Unknown Api Type")
}
